<?php
/* --------------------------------------------------------------
   dependent.inc.php 2019-03-08
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

$t_success &= $this->set_index('orders', 'INDEX', ['customers_id', 'orders_id'], 'customers_id');

// Add PDF_FOOTER_REPLACE_COLUMN configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "PDF_FOOTER_REPLACE_COLUMN"', true);
if($check->num_rows < 1)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key` = "PDF_FOOTER_REPLACE_COLUMN", `gm_value` = "null"';
	$t_success &= $this->query($query) > 0;
}

// Gambio Hub Connector v1.12.1 changes

$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_DATA_OBSERVER"',
                      true);

if($check->num_rows < 1)
{
	$query     = "INSERT INTO `configuration` (`configuration_key`,`configuration_value`,`configuration_group_id`,`sort_order`,`use_function`,`set_function`,`date_added`) VALUES
					('MODULE_PAYMENT_GAMBIO_HUB_DATA_OBSERVER', 'True',6, 1,  '', 'gm_cfg_select_option(array(''True'', ''False''), ', NOW())";
	$t_success &= is_numeric($this->query($query));
}

// Remove the old data observer triggers, if they are still registered.

$check = $this->query('SHOW TRIGGERS LIKE "orders"', true);

if($check->num_rows > 0)
{
	while($row = $check->fetch_assoc())
	{
		if(isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_before_update')
		{
			$query     = 'DROP TRIGGER IF EXISTS `hub_data_changes_orders_before_update`';
			$t_success &= $this->query($query);
		}
		
		if(isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_after_update')
		{
			$query     = 'DROP TRIGGER IF EXISTS `hub_data_changes_orders_after_update`';
			$t_success &= $this->query($query);
		}
	}
}

// START: AutoUpdater v2.1.2

// Add or update AUTO_UPDATER_FEEDBACK_URL gm_configuration value
$check  = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "UPDATE_DOWNLOADER_ACCEPT_DATA_PRIVACY";',
                       true);
$check2 = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "AUTO_UPDATER_ACCEPT_DATA_PROCESSING";',
                       true);
if($check->num_rows > 0 && $check2->num_rows < 1)
{
	$t_success &= $this->query('UPDATE `gm_configuration` SET `gm_key` = "AUTO_UPDATER_ACCEPT_DATA_PROCESSING" WHERE `gm_key` = "UPDATE_DOWNLOADER_ACCEPT_DATA_PRIVACY";')
	              !== false;
}

// Add or update AUTO_UPDATER_UPDATES_URL gm_configuration value
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "AUTO_UPDATER_UPDATES_URL";', true);
if($check->num_rows < 1)
{
	$t_success &= $this->query('
		INSERT INTO `gm_configuration`
		SET `gm_key`    = "AUTO_UPDATER_UPDATES_URL",
			`gm_value`  = "https://updates.gambio-support.de/v2/check.php";
	') !== false;
}
else
{
	$t_success &= $this->query('
		UPDATE  `gm_configuration`
		SET     `gm_value`  = "https://updates.gambio-support.de/v2/check.php"
		WHERE   `gm_key`    = "AUTO_UPDATER_UPDATES_URL";
	') !== false;
}

// Add or update AUTO_UPDATER_FEEDBACK_URL gm_configuration value
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "AUTO_UPDATER_FEEDBACK_URL";', true);
if($check->num_rows < 1)
{
	$t_success &= $this->query('
		INSERT INTO `gm_configuration`
		SET `gm_key`    = "AUTO_UPDATER_FEEDBACK_URL",
			`gm_value`  = "https://updates.gambio-support.de/v2/callingHome.php";
	') !== false;
}
else
{
	$t_success &= $this->query('
		UPDATE  `gm_configuration`
		SET     `gm_value`  = "https://updates.gambio-support.de/v2/callingHome.php"
		WHERE   `gm_key`    = "AUTO_UPDATER_FEEDBACK_URL";
	') !== false;
}

// Add new controller to admin access
if($this->table_exists('admin_access_group_descriptions') && $this->table_exists('admin_access_group_items')
   && $this->table_exists('admin_access_groups'))
{
	/* @var \mysqli_result $groupsQuery */
	$groupsQuery = $this->query('SELECT `admin_access_group_id` FROM `admin_access_group_descriptions` WHERE `name` = "AutoUpdater" GROUP BY `admin_access_group_id`;',
	                            true);
	
	$newControllers = [
		'AutoUpdaterAjax',
		'AutoUpdater',
		'AutoUpdaterShopExcludedAjax',
	];
	
	while($groupsQuery->num_rows > 0 && $group = $groupsQuery->fetch_array())
	{
		foreach($newControllers as $newController)
		{
			$t_success &= $this->query(sprintf('
				REPLACE INTO `admin_access_group_items` (`admin_access_group_id`, `identifier`, `type`)
				VALUES (%d, "%s", "%s");
			', (int)$group['admin_access_group_id'], $newController, 'CONTROLLER')) !== false;
		}
	}
}

// ENDE: AutoUpdater v2.1.2

// START: Google Services v2.1.3

if(!function_exists('insertGoogleConfigIfNotExist'))
{
	function insertGoogleConfigIfNotExist($db, $scope, $option, $default = '\"\"')
	{
		$query = 'SELECT * FROM `google_configurations` WHERE `scope` = "' . $scope . '" AND `option` = "' . $option
		         . '";';
		
		$result = $db->query($query, true);
		
		if($result->num_rows === 0)
		{
			$query = 'INSERT INTO `google_configurations` (`scope`, `option`, `value`) VALUES ("' . $scope . '","'
			         . $option . '","{\"value\":' . $default . '}");';
			
			return $db->query($query) !== false;
		}
		
		return true;
	}
}

if(!$this->table_exists('google_configurations'))
{
	$query     = 'CREATE TABLE `google_configurations` (
	`scope`         ENUM ("general", "adwords", "shopping", "analytics", "auth") NOT NULL,
	`option`        VARCHAR(255)                                         NOT NULL,
	`value`         VARCHAR(255)                                         NOT NULL,
	`last_modified` TIMESTAMP                                            NOT NULL DEFAULT CURRENT_TIMESTAMP
	ON UPDATE CURRENT_TIMESTAMP,
	PRIMARY KEY (`scope`, `option`)
)
	ENGINE = InnoDB
	DEFAULT CHARSET = `utf8`;';
	$t_success &= $this->query($query, true);
}

if(!$this->table_exists('google_adwords_client_customers'))
{
	$query     = 'CREATE TABLE `google_adwords_client_customers` (
  `client_customer_id` varchar(12) NOT NULL,
  `primary` int(1) NOT NULL DEFAULT "0",
  PRIMARY KEY (`client_customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ;';
	$t_success &= $this->query($query, true);
}

// check and try to export old google configuration values
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"', true);
if($check->num_rows === 1)
{
	$connectionStatus = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"');
	
	$connected = array_key_exists(0, $connectionStatus)
	             && $connectionStatus[0]['gm_value'] === 'true' ? 'true' : 'false';
	
	$query     = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"';
	$t_success &= $this->query($query, true);
	
	$check = $this->query('SELECT * FROM `google_configurations` WHERE `scope` = "general" AND `option` = "connection-status"',
	                      true);
	
	if($check->num_rows < 1)
	{
		$query     = 'REPLACE INTO `google_configurations` (`scope`, `option`, `value`) VALUES
			("general", "connection-status", "{\"value\": ' . $connected . '}")';
		$t_success &= $this->query($query, true);
	}
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"', true);
if($check->num_rows === 1)
{
	$refreshTokenResult = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"');
	$refreshToken       = array_key_exists(0, $refreshTokenResult) ? $refreshTokenResult[0]['gm_value'] : '';
	
	$query     = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"';
	$t_success &= $this->query($query, true);
	
	$check = $this->query('SELECT * FROM `google_configurations` WHERE `scope` = "auth" AND `option` = "refresh-token"',
	                      true);
	
	if($check->num_rows < 1)
	{
		$query     = 'REPLACE INTO `google_configurations` (`scope`, `option`, `value`) VALUES
			("auth", "refresh-token", "{\"value\": \"' . $refreshToken . '\"}")';
		$t_success &= $this->query($query, true);
	}
}

// Add export_type for google shopping
$check = $this->query('SELECT * FROM `export_types` WHERE `type_id` = 3 AND `language_id` = 1', true);

if($check->num_rows < 1)
{
	$query     = 'INSERT INTO `export_types`
					SET `name` = "Google Shopping",
						`language_id` = 1,
						`type_id` = 3';
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `export_types` WHERE `type_id` = 3 AND `language_id` = 2', true);
if($check->num_rows < 1)
{
	$query     = 'INSERT INTO `export_types`
					SET `name` = "Google Shopping",
						`language_id` = 2,
						`type_id` = 3';
	$t_success &= $this->query($query, true);
}

if(!$this->table_column_exists('export_scheme_fields', 'status'))
{
	$query     = 'ALTER TABLE `export_scheme_fields` ADD `status` tinyint(1) NOT NULL DEFAULT 1';
	$t_success &= $this->query($query, true);
}

insertGoogleConfigIfNotExist($this, 'general', 'connection-status', 'false');
insertGoogleConfigIfNotExist($this, 'auth', 'refresh-token');
insertGoogleConfigIfNotExist($this, 'auth', 'access-token');
insertGoogleConfigIfNotExist($this, 'auth', 'expiration-timestamp');
insertGoogleConfigIfNotExist($this, 'analytics', 'ua-tracking-code');
insertGoogleConfigIfNotExist($this, 'analytics', 'enabled', 'false');
insertGoogleConfigIfNotExist($this, 'analytics', 'anonymize-ip', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'price-net', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-impression-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'listing-impression-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'product-click-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'product-details-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'shopping-cart-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'checkout-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'dev-mode', 'false');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-bestseller-name', '\"Bestseller Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-specials-name', '\"Specials Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-whats-new-name', '\"Whats New Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-bestseller-name', '\"Bestseller List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-specials-name', '\"Specials List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-new-products-name', '\"New Products List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-whats-new-name', '\"Whats New List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-available-soon-name', '\"Available Soon List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-top-products-name', '\"Top Products List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'gtag-js-file-name');
insertGoogleConfigIfNotExist($this, 'analytics', 'analytics-js-file-name');
insertGoogleConfigIfNotExist($this, 'analytics', 'ec-plugin-js-file-name');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-tracking-enabled', 'false');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-name');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-id');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-action-id');

if(method_exists($this, 'addAdminAccessGroup') && $this->table_exists('admin_access_groups'))
{
	// add google backend controller to admin access
	$latestSortOrder = $this->query('SELECT `sort_order` FROM `admin_access_groups` ORDER BY `sort_order` DESC LIMIT 1');
	$sortOrder       = (int)$latestSortOrder['sort_order'] + 1;
	
	$insertedGroupIds = [];
	
	$check = $this->query('SELECT * FROM `admin_access_group_items` WHERE `type` = "CONTROLLER" AND `identifier` = "GoogleShopping"',
	                      true);
	
	if($check->num_rows < 1)
	{
		$groupId = $this->addAdminAccessGroup(array(1 => 'Google Shopping', 2 => 'Google Shopping'), array(
			1 => 'Allows the usage of Google Shopping.',
			2 => 'Erlaubt die Nutzung von Google Shopping.',
		), $sortOrder++, 10);
		if($groupId !== false)
		{
			$t_success          &= $this->addAdminAccessGroupItem($groupId, 'CONTROLLER', array(
				'GoogleShopping',
				'GoogleShoppingAjax',
			));
			$insertedGroupIds[] = $groupId;
		}
		else
		{
			$t_success = false;
		}
	}
	
	$check = $this->query('SELECT * FROM `admin_access_group_items` WHERE `type` = "CONTROLLER" AND `identifier` = "GoogleAdWords"',
	                      true);
	if($check->num_rows < 1)
	{
		$groupId = $this->addAdminAccessGroup(array(1 => 'Google Ads', 2 => 'Google Ads'), array(
			1 => 'Allows the usage of Google Ads.',
			2 => 'Erlaubt die Nutzung von Google Ads.',
		), $sortOrder++, 10);
		if($groupId !== false)
		{
			$t_success          &= $this->addAdminAccessGroupItem($groupId, 'CONTROLLER', array(
				'GoogleAdWords',
				'AdWordsCampaignsOverviewAjax',
			));
			$insertedGroupIds[] = $groupId;
		}
		else
		{
			$t_success = false;
		}
	}
	
	$check = $this->query('SELECT * FROM `admin_access_group_items` WHERE `type` = "CONTROLLER" AND `identifier` = "GoogleAnalyticsAdmin"',
	                      true);
	if($check->num_rows < 1)
	{
		$groupId = $this->addAdminAccessGroup(array(1 => 'Google Analytics', 2 => 'Google Analytics'), array(
			1 => 'Allows the usage of Google Analytics.',
			2 => 'Erlaubt die Nutzung von Google Analytics.',
		), $sortOrder++, 10);
		if($groupId !== false)
		{
			$t_success          &= $this->addAdminAccessGroupItem($groupId, 'CONTROLLER', array(
				'GoogleAnalyticsAdmin',
			));
			$insertedGroupIds[] = $groupId;
		}
		else
		{
			$t_success = false;
		}
	}
	
	$adminAccessRoles = $this->query('SELECT `admin_access_role_id` FROM `admin_access_roles`;');
	
	if(is_array($adminAccessRoles))
	{
		foreach($adminAccessRoles as $adminAccessRole)
		{
			$roleId = $adminAccessRole['admin_access_role_id'];
			
			foreach($insertedGroupIds as $groupId)
			{
				$this->grantAdminAccessPermission($roleId, $groupId);
			}
		}
	}
	else
	{
		$t_success = false;
	}
}

// ENDE: Google Services v2.1.3


// delete duplicate entries in zones_to_geo_zones table for Montenegro

$result = $this->query('SELECT `countries_id` FROM `countries` WHERE `countries_iso_code_2` = "ME"');
$montenegroCountryId = $result[0]['countries_id'];
if($montenegroCountryId)
{
	$check = $this->query('SELECT * FROM `zones_to_geo_zones`
							WHERE
								`zone_country_id` = ' . (int)$montenegroCountryId . ' AND
								`geo_zone_id` = 5', true);
	if($check->num_rows > 1)
	{
		$query = 'DELETE FROM `zones_to_geo_zones`
					WHERE
						`zone_country_id` = ' . (int)$montenegroCountryId . ' AND
						`geo_zone_id` = 5';
		$t_success &= is_numeric($this->query($query));
		
		$query = 'INSERT INTO `zones_to_geo_zones`
					 SET `zone_country_id` = ' . (int)$montenegroCountryId . ',
					 	 `geo_zone_id` = 5,
					 	 `last_modified` = "' . date('Y-m-d H:i:s') . '",
					 	 `date_added` =  "' . date('Y-m-d H:i:s') . '"';
		
		$t_success &= $this->query($query, true);
	}
}