<?php
/* --------------------------------------------------------------
   dependent.inc.php 2019-03-19
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

// Remove the old data observer triggers, if they are still registered.

$check = $this->query('SHOW TRIGGERS LIKE "orders"', true);

if($check->num_rows > 0)
{
	while($row = $check->fetch_assoc())
	{
		if(isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_before_update')
		{
			$query     = 'DROP TRIGGER IF EXISTS `hub_data_changes_orders_before_update`';
			$t_success &= $this->query($query);
		}
		
		if(isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_after_update')
		{
			$query     = 'DROP TRIGGER IF EXISTS `hub_data_changes_orders_after_update`';
			$t_success &= $this->query($query);
		}
		
		if(isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_before_delete')
		{
			$query     = 'DROP TRIGGER IF EXISTS `hub_data_changes_orders_before_delete`';
			$t_success &= $this->query($query);
		}
	}
}

// repair empty values in language records

$check      = 'SELECT 
				`languages_id`, 
				`code` 
			FROM `languages` 
			WHERE 
				`date_format` = "" OR 
				`date_format_long` = "" OR 
				`date_format_short` = "" OR 
				`date_time_format` = "" OR 
				`dob_format_string` = "" OR 
				`html_params` = "" OR 
				`language_currency` = "" OR 
				`php_date_time_format` = ""';
$langResult = $this->query($check);
$t_success  &= is_array($langResult);

foreach($langResult as $language)
{
	if($language['code'] === 'de')
	{
		$query     = 'UPDATE `languages` SET `date_format` = "d.m.Y" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_format` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `date_format_long` = "%A, %d. %B %Y" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_format_long` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `date_format_short` = "%d.%m.%Y" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_format_short` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `date_time_format` = "%d.%m.%Y %H:%M:%S" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_time_format` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `dob_format_string` = "tt.mm.jjjj" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `dob_format_string` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `html_params` = \'dir="ltr" lang="de"\' WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `html_params` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `language_currency` = "EUR" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `language_currency` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `php_date_time_format` = "d.m.Y H:i:s" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `php_date_time_format` = ""';
		$t_success &= is_numeric($this->query($query));
	}
	else
	{
		$query     = 'UPDATE `languages` SET `date_format` = "m/d/Y" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_format` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `date_format_long` = "%A, %d. %B %Y" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_format_long` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `date_format_short` = "%m/%d/%Y" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_format_short` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `date_time_format` = "%m/%d/%Y %H:%M:%S" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `date_time_format` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `dob_format_string` = "mm/dd/yyyy" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `dob_format_string` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `html_params` = \'dir="ltr" lang="' . $language['code']
		             . '"\' WHERE `languages_id` = ' . $language['languages_id'] . ' AND `html_params` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$currency = $language['code'] === 'en' ? 'USD' : 'EUR';
		
		$query     = 'UPDATE `languages` SET `language_currency` = "' . $currency . '" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `language_currency` = ""';
		$t_success &= is_numeric($this->query($query));
		
		$query     = 'UPDATE `languages` SET `php_date_time_format` = "m/d/Y H:i:s" WHERE `languages_id` = '
		             . $language['languages_id'] . ' AND `php_date_time_format` = ""';
		$t_success &= is_numeric($this->query($query));
	}
}